﻿Imports System.Windows.Forms

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Initialize the ComboBox for tags and inclusion options
        Dim tagOptions As String() = {"p", "h1", "h2", "h3", "h4", "h5", "h6", "span"}
        Dim includeOptions As String() = {"Yes", "No"}

        ComboBoxTags.Items.AddRange(tagOptions)
        ComboBoxInclude.Items.AddRange(includeOptions)

        ' Set default values
        TrackBarParagraphs.Value = 1
        TrackBarParagraphs.Minimum = 1
        TrackBarParagraphs.Maximum = 50
        TrackBarWords.Value = 10
        TrackBarWords.Minimum = 1
        TrackBarWords.Maximum = 200
        LabelParagraphsValue.Text = TrackBarParagraphs.Value.ToString()
        LabelWordsValue.Text = TrackBarWords.Value.ToString()
    End Sub

    Private Sub TrackBarParagraphs_Scroll(sender As Object, e As EventArgs) Handles TrackBarParagraphs.Scroll
        LabelParagraphsValue.Text = TrackBarParagraphs.Value.ToString()
    End Sub

    Private Sub TrackBarWords_Scroll(sender As Object, e As EventArgs) Handles TrackBarWords.Scroll
        LabelWordsValue.Text = TrackBarWords.Value.ToString()
    End Sub

    Private Sub ButtonGenerate_Click(sender As Object, e As EventArgs) Handles ButtonGenerate.Click
        Dim paragraphs As Integer = TrackBarParagraphs.Value
        Dim wordsPerParagraph As Integer = TrackBarWords.Value
        Dim selectedTag As String = ComboBoxTags.SelectedItem?.ToString()
        Dim includeHtml As String = ComboBoxInclude.SelectedItem?.ToString()

        Dim generatedText As String = GenerateLoremIpsum(paragraphs, selectedTag, includeHtml, wordsPerParagraph)
        TextBoxOutput.Text = generatedText
    End Sub

    Private Function GenerateLoremIpsum(paragraphs As Integer, tag As String, includeHtml As String, wordsPerParagraph As Integer) As String
        Dim loremIpsumText As String = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Diam in arcu cursus euismod quis viverra nibh. Nunc aliquet bibendum enim facilisis gravida neque convallis a cras. Sagittis purus sit amet volutpat Consequat mauris. Duis ultricies lacus sed turpis tincidunt id. Consequat interdum varius sit amet mattis vulputate. Enim sed faucibus turpis in eu. Ridiculus mus mauris vitae ultricies leo integer malesuada nunc vel. Nulla pharetra diam sit amet nisl suscipit. Lobortis elementum nibh tellus molestie nunc non blandit massa enim. Dis parturient montes nascetur ridiculus mus. Justo nec ultrices dui sapien eget. Enim tortor at auctor urna nunc. Dictumst quisque sagittis purus sit amet volutpat consequat mauris nunc."

        Dim paragraphsList As New List(Of String)
        For i As Integer = 1 To paragraphs
            Dim words As String = GenerateWords(wordsPerParagraph, loremIpsumText)
            If includeHtml = "Yes" Then
                paragraphsList.Add($"<{tag}>{words}</{tag}>")
            Else
                paragraphsList.Add(words)
            End If
        Next

        Return String.Join(Environment.NewLine, paragraphsList)
    End Function

    Private Function GenerateWords(numWords As Integer, loremText As String) As String
        Dim words As String() = loremText.Split(New Char() {" "c}, StringSplitOptions.RemoveEmptyEntries)

        If numWords <= words.Length Then
            Return String.Join(" ", words.Take(numWords))
        Else
            Return String.Join(" ", words)
        End If
    End Function

End Class
